//+------------------------------------------------------------------+
//|                                                 Mirror_Bands.mq4 |
//|                           Copyright  2015 Kosta                 |
//|                                            mt4.kosta@gmail.com   |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2015 Kosta"
#property  link      "mt4.kosta@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
#property  indicator_width1  1

//---- indicator parameters
extern int    BandsPeriod=30;
extern int    BandsPeriod2=1;
extern int    BandsShift=0;
//extern double BandsDeviations=2.0;
//---- buffers
double MovingBuffer[];
//double UpperMirror[];
double LowerMirror[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   SetIndexBuffer(0,LowerMirror);
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();

   double sum,oldval,newres;
//----

//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=LowerMirror[i+1];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }



      LowerMirror[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_EMA,PRICE_CLOSE,i)+(iMA(NULL,0,BandsPeriod,BandsShift,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,BandsPeriod2,BandsShift,MODE_SMA,PRICE_CLOSE,i));
      i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+